using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace GDBGProblemSample
{
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.ComponentModel.Container components = null;
		private Syncfusion.Windows.Forms.Grid.GridBoundColumn gridBoundColumn1;
		private System.Windows.Forms.DataGrid dataGrid1;
		DataTable table = new DataTable();

		public Form1() {
			InitializeComponent();
			table.Columns.Add("ID", typeof(int));
			table.Columns.Add("VALUE", typeof(string));
			for(int i=0; i<10; ++i) {
				table.LoadDataRow(new object[] {i, "Sample"+i}, false);
			}
			table.AcceptChanges();
			gridDataBoundGrid1.DataSource = table;
			gridDataBoundGrid1.Binder.DirectSaveCellInfo = true;
//			dataGrid1.DataSource = table;
		}


		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null)  components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.gridBoundColumn1 = new Syncfusion.Windows.Forms.Grid.GridBoundColumn();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.ActivateCurrentCellBehavior = Syncfusion.Windows.Forms.Grid.GridCellActivateAction.DblClickOnCell;
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.GridBoundColumns.AddRange(new Syncfusion.Windows.Forms.Grid.GridBoundColumn[] {
																													  this.gridBoundColumn1});
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(8, 8);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.Properties.BackgroundColor = System.Drawing.SystemColors.Window;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(144, 248);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			this.gridDataBoundGrid1.CurrentCellValidated += new System.EventHandler(this.gridDataBoundGrid1_CurrentCellValidated);
			this.gridDataBoundGrid1.CurrentCellChanging += new System.ComponentModel.CancelEventHandler(this.gridDataBoundGrid1_CurrentCellChanging);
			// 
			// gridBoundColumn1
			// 
			this.gridBoundColumn1.HeaderText = "The Value";
			this.gridBoundColumn1.MappingName = "VALUE";
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(184, 8);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(240, 256);
			this.dataGrid1.TabIndex = 1;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(432, 397);
			this.Controls.Add(this.dataGrid1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void gridDataBoundGrid1_CurrentCellValidated(object sender, System.EventArgs e) {
			// I need to update the database here (adapter.Update()). But the new value is not in the table
			gridDataBoundGrid1.Binder.EndEdit();
			gridDataBoundGrid1.BindingContext[gridDataBoundGrid1.DataSource].EndCurrentEdit();
			int a = 0;
		}

		private void gridDataBoundGrid1_CurrentCellChanging(object sender, System.ComponentModel.CancelEventArgs e) {
			e.Cancel = gridDataBoundGrid1.CurrentCell.Renderer.ControlText.Length==0;
		}
	}
}
